<template>
  <div class="edit-codes">
    <div >
      <div class="promo-filters">
        <button @click="createPromoForm = true;" class="action-button main-button mb-2 create-button">Создать Промокод</button>
        <div>
          <input type="text" placeholder="Поиск ..." class="main-input promo-search" v-model="filterKey">
        </div>
      </div>

      <div>
        <table class="table app-table">
          <thead>
            <tr>
              <th>Скидка</th>
              <th>Код</th>
              <th>Действителен с</th>
              <th>Действителен до</th>
              <th>Категории</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="item in limitedData">
              <td><div class="discount-cell"><span>{{item.discount}} %</span></div></td>
              <td>{{item.code}}</td>
              <td>{{item.activeFrom}}</td>
              <td>{{item.activeTo}}</td>
              <td>{{item.categories}}</td>
              <td>
                <div>
                  <button class="action-button main-button" @click="setEditItem(item)">ИЗМЕНИТЬ</button>
                  <button class="action-button delete-button mt-1" @click="setDeleteItem(item)">УДАЛИТЬ</button>
                </div>
              </td>
            </tr>
          </tbody>
        </table>

        <nav class="navigation pagination" v-if="noPages.length > 1">
          <div class="nav-links">
            <a :class="{disabled: (currentPage === 0)}" @click="previous" class="prev page-numbers">Предыдущая</a>
            <a v-for="(page, ind) in noPages" class="page-numbers" :class="{current: page === currentPage}" @click='(e) => {goToPage(page, e)}'><span class="meta-nav screen-reader-text"></span>{{page + 1}}</a>
            <a :class="{disabled: (currentPage + 1 === noPages.length)}" class="next page-numbers" @click="next">Следующая</a>
          </div>
        </nav>
      </div>
    </div>

    <modal :header="'Подтвердите Действие'" :isShow="showDeleteModal" v-if="showDeleteModal" @close="showDeleteModal = false">
      <div slot="body">
        <p>Вы уверены, что хотите удалть промокод ?</p>
        <button class="ml-2 action-button delete-button pull-right" @click="confirmDelete">УДАЛИТЬ</button>
      </div>

      <div slot="footer">
      </div>
    </modal>

    <promo-form v-if="editPromoForm" :promo="editItem" @promo="addNewPromo" @close="editPromoForm = false;" :categories="categories"></promo-form>
    <promo-form v-if="createPromoForm" @promo="addNewPromo" @close="createPromoForm = false;" :categories="categories"></promo-form>
  </div>
</template>
<script>
import Modal from "@/components/shared/Modal";
import PromoForm from "@/components/promo/PromoForm";
export default {
  data() {
    return {
      codes: undefined, categories: undefined,
      loading: false, showDeleteModal: false, createPromoForm: false, editPromoForm: false,
      currentPage: 0,
      filterKey: ''
    }
  },
  methods: {
    getCodes,
    getCategories,
    setDeleteItem,
    setEditItem,
    confirmDelete,
    addNewPromo,
    previous: function (e) { // Previous page click handler
      e.preventDefault()
      if (this.currentPage !== 0) {
        --this.currentPage
      }
    },
    next: function (e) { // Next page click handler
      e.preventDefault()
      if (this.currentPage + 1 !== this.noPages.length) {
        ++this.currentPage
      }
    },
    goToPage: function (page, e) { // Go to a specific page click handler
      e.preventDefault();
      this.currentPage = page;
    },
    firstPage: function(e) {
      e.preventDefault();
      this.currentPage = 0;
    }
  },
  computed: {
    noPages: function () { // No. pages as an array. Used for rendering paginator
      if (!this.filteredData) return [];
      let pages = Math.ceil(this.filteredData.length / 10);
      pages = [...Array(pages).keys()];
      pages = pages.filter(num => {
        return num < this.currentPage + 10 && num > this.currentPage - 10;
      }); 

      return pages;
    },
    limitedData: function () { 
      if (!this.filteredData) return [];
      let limitedData = this.filteredData.slice(
        this.currentPage * 10,
        10 * (this.currentPage + 1)
      );
      return limitedData;
    },
      filteredData: function () { // Data filtered through the local search
        if (!this.codes) return [];
        var filterKey = this.filterKey && this.filterKey.toLowerCase();
        var data = this.codes;
        if (filterKey) {
          data = data.filter((pr) => pr.code.toLowerCase().indexOf(filterKey) > -1 || pr.discount.toString().indexOf(filterKey.toString()) > -1);
        }

        return data
      }
  },
  components: {
    Modal, PromoForm
  },
  mounted() {
    this.getCodes();
    this.getCategories();
  }
}

function addNewPromo(promo) {
  promo.activeFrom = this.$moment(promo.activeFrom).format('DD MMM YYYY');
  promo.activeTo = this.$moment(promo.activeTo).format('DD MMM YYYY');
  promo.categories = promo.categories.join(', ');

  if (this.codes.map(c => c._id).includes(promo._id)) {
    this.codes.some((c, ind, arr) => {
      if (c._id === promo._id) {
        arr.splice(ind, 1, promo);
        return true;
      }
    });
  } else {
    this.codes.push(promo);
  }

  this.createPromoForm = false;
  this.editPromoForm = false;
}

function setDeleteItem(item) {
  this.itemToDelete = item._id;
  this.showDeleteModal = true;
}

function confirmDelete() {
  this.codes.some((i, ind, arr) => {
    if (i._id === this.itemToDelete) {
      arr.splice(ind, 1);
      return true;
    }
  });
  this.showDeleteModal = false;
  this.$http.delete(`${process.env.VUE_APP_BASE_URL}/promo-codes/${this.itemToDelete}`).catch(err => {
    console.log(err);
  })
}

function setEditItem(item) {
  this.editItem = item;
  this.editPromoForm = true;
}

function getCodes() {
  this.loading = true;
  this.$http
    .get(`${process.env.VUE_APP_BASE_URL}/promo-codes`)
    .then(response => {
      response.data.forEach(c => {
        c.activeFrom = this.$moment(c.activeFrom).format('DD MMM YYYY');
        c.activeTo = this.$moment(c.activeTo).format('DD MMM YYYY');
        c.categories = c.categories.join(', ');
      });
      this.loading = false;
      this.codes = response.data;
    })
    .catch(error => {
      console.log(error);
    });
}

function getCategories() {
  this.loading = true;
  this.$http
    .get(`${process.env.VUE_APP_BASE_URL}/products/categories`)
    .then(response => {
      this.categories = response.data;
    })
    .catch(error => {
      console.log(error);
    });
}

</script>
<style lang="scss">
  .edit-codes {
    min-height: 400px;
    table .action-button {
      margin-top: 0;
      padding: 5px 10px;
    }
    .promo-filters {
      display: flex;
      justify-content: space-between;
      .create-button {
        max-width: 200px;
        padding: 8px 5px;
        margin-top: 0;
      }
      .promo-search {
        max-width: 200px;
        margin-top: 10px;
      }
    }
    .m-dropdown {
      display: inline-block;
      min-width: 200px;
    }
    .discount-cell {

      height: 60px;
      width: 60px;
      background-color: #ede8d7;
      text-align: center;

      span {
        line-height: 60px;
        font-size: 22px;
        color: gray;
      }
    }
  }
</style>